local months = {"January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"}
local days_in_month = {31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31}
local days_of_week = {"Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"}

local function is_leap_year(year)
    return year % 4 == 0 and (year % 100 ~= 0 or year % 400 == 0)
end

local function print_month(year, month)
    local days = days_in_month[month]
    if month == 2 and is_leap_year(year) then
        days = 29
    end
    local weeks = math.ceil(days / 7)
    if days == 31 then
        print(months[month] .. " " .. year .. " (" .. weeks .. " weeks, 31 days)")
    elseif days == 30 then
        print(months[month] .. " " .. year .. " (" .. weeks .. " weeks, 30 days)")
    elseif days == 28 or days == 29 then
        print(months[month] .. " " .. year .. " (" .. weeks .. " weeks, " .. days .. " days)")
    end
    local day = 1
    local week = 1
    print("Week " .. week)
    while day <= days do
        local row = ""
        for i = 1, 7 do
            if day <= days then
                local date = os.date("*t", os.time { year = year, month = month, day = day })
                local day_name = days_of_week[date.wday]
                row = row .. string.format("%3d (%s) ", day, day_name)
                day = day + 1
            else
                row = row .. " "
            end
        end
        print(row)
        if week == 1 and day > 7 then
            week = week + 1
            print("Week " .. week)
        elseif week == 2 and day > 14 then
            week = week + 1
            print("Week " .. week)
        elseif week == 3 and day > 21 then
            week = week + 1
            print("Week " .. week)
        elseif week == 4 and day > 28 and day <= days then
            week = week + 1
            print("Week " .. week)
        end
    end
end

local current_date = os.date("*t")
local current_year = current_date.year
local current_month = current_date.month
local current_day = current_date.day
local current_hour = current_date.hour
local current_minute = current_date.min
local current_second = current_date.sec
local current_day_name = days_of_week[current_date.wday]
local hour = current_hour % 12
if hour == 0 then
    hour = 12
end

print("Current Date and Time: " .. current_day_name .. ", " .. months[current_month] .. " " .. current_day .. ", " .. current_year .. " " .. hour .. ":" .. string.format("%02d:%02d", current_minute, current_second) .. " " .. (current_hour < 12 and "AM" or "PM"))

print("Created by Zafar Abbas")

for month = 1, 12 do
    print_month(current_year, month)
end

print("Contact Me on WhatsApp: https://wa.me/923069574435?text=Hello%20Zafar%20Abbas")

